Attribute VB_Name = "basMain"
' Error handler test/sample/"error handling template" application
' Author: Yuri Volkov, programmer@iname.com
' v. 2003-10-03
'-------------------------------------------------------------------------------
' Additional libraries, requires for _this_ test application:
' 1. "Microsoft ActiveX Data Objects 2.7 Library"
' 2. "Microsoft XML, v4.0"
' _None_ of these libraries is required for YOUR application
'   (see yvErrorHandler module for more info)
Option Explicit
Private Const conModuleName As String = "basMain"

'Some public object, that lives during the whole app execution
'yvErrorHandler may live without it:
'  just declare it as Object and leave it uninitialized
Public AppGlobals As SampleGlobalsClass

' App.EXEName
' For unattended error logging this is the name of directory for log files
' (see yvErrorHandler:MyLogEvent function)
Global gstrApp_EXEName As String
' Full app name, including version number
Global gstrTitle As String
' Unattended execution?
Global gblnUnattendedApp As Boolean
Global gstrDirWorking As String

'Debug mode may be switched on...
Global gblnDebug As Boolean
Private mClassDebugID As Long

'Test/sample form
Public frmMain1 As frmMain

Public Sub Main()
Const conModuleSubName = conModuleName & ":" & "Main"
Dim blnOk As Boolean
  On Error GoTo ErrProc
  
  Call InitializeProgram
  
  If frmMain1.Initialized Then
    frmMain1.Visible = True
  Else
    GoTo ExitProc
  End If
  
  DoEvents
  
OkProc:
  blnOk = frmMain1.Visible
ExitProc:
  On Error Resume Next
  If blnOk Then
    MySleep 2
    frmMain1.SetFocus
    MySleep 1
    frmMain1.SetFocus
  Else
    Call ReleaseProgram
  End If
  Exit Sub

ErrProc:
  ShowError conModuleSubName
  blnOk = False
  Resume ExitProc
End Sub

Public Sub InitializeProgram()
Const conModuleSubName = conModuleName & ":" & "InitializeProgram"
Dim blnOk As Boolean
  On Error GoTo ErrProc
  gstrApp_EXEName = App.EXEName
  gstrTitle = App.ProductName & " v. " & FullVersionNumber()
  gstrDirWorking = AddDirSep(CurDir)  ' Environ("TEMP")
  
  gblnUnattendedApp = App.UnattendedApp
  
  gblnDebug = True
  
  mClassDebugID = GetNextClassDebugID()
  MyLogEvent "id=" & CStr(mClassDebugID) & ";event=started;app='" & gstrTitle & "'"
  Set AppGlobals = New SampleGlobalsClass
  Set frmMain1 = New frmMain
  'load form
  frmMain1.Visible = True
  
OkProc:
  blnOk = True
ExitProc:
  On Error Resume Next
  Exit Sub

ErrProc:
  ShowError conModuleSubName
  blnOk = False
  Resume ExitProc
End Sub

Public Sub ReleaseProgram()
Const conModuleSubName = conModuleName & ":" & "ReleaseProgram"
Static blnBusy As Boolean
Dim blnOk As Boolean
Dim lng1 As Long
  If blnBusy Then Exit Sub
  blnBusy = True
  
  On Error Resume Next

  If Not frmMain1 Is Nothing Then
    frmMain1.Visible = False
    DoEvents
    frmMain1.Release
    Unload frmMain1
    Set frmMain1 = Nothing
  End If
  
  'close all sub forms
  For lng1 = Forms.Count - 1 To 1 Step -1
    Unload Forms(lng1)
  Next
  
  Set AppGlobals = Nothing
  
OkProc:
  blnOk = True

ExitProc:
  On Error Resume Next
  blnBusy = False
  Exit Sub

ErrProc:
  ShowError conModuleSubName
  blnOk = False
  Resume ExitProc
End Sub

